if __FILE__ == $0
	require 'ffi'

	# FIXME: dirty fix to propagate FFI structs layout down the inheritance hierarchy
	# TODO: switch to composition instead inheriting FFI structs
	module PropagateFFIStructLayout
		def inherited(child_class)
			child_class.instance_variable_set '@layout', layout
		end
	end

	class FFI::Struct
		def self.inherited(child_class)
			child_class.extend PropagateFFIStructLayout
		end
	end
	# END FIXME
end

require_relative '../user'

module Fzeet
	module Windows
		ffi_lib 'comctl32'
		ffi_convention :stdcall

		ICC_LISTVIEW_CLASSES = 0x00000001
		ICC_TREEVIEW_CLASSES = 0x00000002
		ICC_BAR_CLASSES = 0x00000004
		ICC_TAB_CLASSES = 0x00000008
		ICC_UPDOWN_CLASS = 0x00000010
		ICC_PROGRESS_CLASS = 0x00000020
		ICC_HOTKEY_CLASS = 0x00000040
		ICC_ANIMATE_CLASS = 0x00000080
		ICC_WIN95_CLASSES = 0x000000FF
		ICC_DATE_CLASSES = 0x00000100
		ICC_USEREX_CLASSES = 0x00000200
		ICC_COOL_CLASSES = 0x00000400
		ICC_INTERNET_CLASSES = 0x00000800
		ICC_PAGESCROLLER_CLASS = 0x00001000
		ICC_NATIVEFNTCTL_CLASS = 0x00002000
		ICC_STANDARD_CLASSES = 0x00004000
		ICC_LINK_CLASS = 0x00008000

		class INITCOMMONCONTROLSEX < FFI::Struct
			layout \
				:dwSize, :ulong,
				:dwICC, :ulong
		end

		attach_function :InitCommonControlsEx, [:pointer], :int

		CCS_TOP = 0x00000001
		CCS_NOMOVEY = 0x00000002
		CCS_BOTTOM = 0x00000003
		CCS_NORESIZE = 0x00000004
		CCS_NOPARENTALIGN = 0x00000008
		CCS_ADJUSTABLE = 0x00000020
		CCS_NODIVIDER = 0x00000040
		CCS_VERT = 0x00000080
		CCS_LEFT = CCS_VERT | CCS_TOP
		CCS_RIGHT = CCS_VERT | CCS_BOTTOM
		CCS_NOMOVEX = CCS_VERT | CCS_NOMOVEY

		CCM_FIRST = 0x2000
		CCM_LAST = CCM_FIRST + 0x200
		CCM_SETBKCOLOR = CCM_FIRST + 1
		CCM_SETCOLORSCHEME = CCM_FIRST + 2
		CCM_GETCOLORSCHEME = CCM_FIRST + 3
		CCM_GETDROPTARGET = CCM_FIRST + 4
		CCM_SETUNICODEFORMAT = CCM_FIRST + 5
		CCM_GETUNICODEFORMAT = CCM_FIRST + 6
		CCM_SETVERSION = CCM_FIRST + 0x7
		CCM_GETVERSION = CCM_FIRST + 0x8
		CCM_SETNOTIFYWINDOW = CCM_FIRST + 0x9
		CCM_SETWINDOWTHEME = CCM_FIRST + 0xb
		CCM_DPISCALE = CCM_FIRST + 0xc

		NM_FIRST = 0x1_0000_0000
		NM_LAST = 0x1_0000_0000 - 99
		NM_OUTOFMEMORY = NM_FIRST - 1
		NM_CLICK = NM_FIRST - 2
		NM_DBLCLK = NM_FIRST - 3
		NM_RETURN = NM_FIRST - 4
		NM_RCLICK = NM_FIRST - 5
		NM_RDBLCLK = NM_FIRST - 6
		NM_SETFOCUS = NM_FIRST - 7
		NM_KILLFOCUS = NM_FIRST - 8
		NM_CUSTOMDRAW = NM_FIRST - 12
		NM_HOVER = NM_FIRST - 13
		NM_NCHITTEST = NM_FIRST - 14
		NM_KEYDOWN = NM_FIRST - 15
		NM_RELEASEDCAPTURE = NM_FIRST - 16
		NM_SETCURSOR = NM_FIRST - 17
		NM_CHAR = NM_FIRST - 18
		NM_TOOLTIPSCREATED = NM_FIRST - 19
		NM_LDOWN = NM_FIRST - 20
		NM_RDOWN = NM_FIRST - 21
		NM_THEMECHANGED = NM_FIRST - 22
		NM_FONTCHANGED = NM_FIRST - 23
		NM_CUSTOMTEXT = NM_FIRST - 24
		NM_TVSTATEIMAGECHANGING = NM_FIRST - 24
	end
end
